Create design
Creates a new Canva design. To create a new design, you can:
-
Use a preset design type.
-
Set height and width dimensions for a custom design.
Custom designs can have a maximum area of 25,000,000 pixels squared (for example, 5000 × 5000 pixels). Each dimension can be between 40 and 8000 pixels, but the total area must stay within this limit.
-
Create a copy of an existing design (currently a preview feature).
-
Create a new design from a brand template (currently a preview feature).
For preset and custom designs, you can also provide the asset_id of an asset in the user's projects(opens in a new tab or window) to add to the new design. Currently, this only supports image assets. To list the assets in a folder in the user's projects, use the List folder items API.
Blank designs created with this API are automatically deleted if they're not edited within 7 days. These blank designs bypass the user's Canva trash and are permanently deleted.
HTTP method and URL path
https://api.canva.com /rest /v1 /designsThis operation is rate limited to 20 requests per minute for each user of your integration.
Authentication and authorization
This endpoint requires a valid access token that acts on behalf of a user.
Scopes
The access token must have all the following scopes (permissions):
design:content:write
Header parameters
Content-TypestringIndicates the media type of the information sent in the request. This must be set to application/json.
For example: Content-Type: application/json
Body parameters
Create a design by specifying the design type and/or an asset.
At least one of design_type or asset_id must be defined.
typestringFor backward compatibility, if type isn't specified in the request, the request type will be assumed to be type_and_asset.
Available values: The only valid value is type_and_asset.
design_typeDesignTypeInputThe desired design type.
Provide the common design type.
typestringAvailable values: The only valid value is preset.
namestringThe name of the design type.
Available values:
doc: A Canva doc(opens in a new tab or window); a document for Canva's online text editor.email: An email(opens in a new tab or window); for creating email campaign designs.presentation: A presentation(opens in a new tab or window); lets you create and collaborate for presenting to an audience.whiteboard: A whiteboard(opens in a new tab or window); a design which gives you infinite space to collaborate.
Provide the width and height to define a custom design type.
Each dimension must be between 40 and 8000 pixels, and the total area (width × height) must not exceed 25,000,000 pixels squared. For example, a design with a width of 8000 pixels can have a maximum height of 3125 pixels.
typestringAvailable values: The only valid value is custom.
widthintegerThe width of the design, in pixels.
Minimum: 40
Maximum: 8000
heightintegerThe height of the design, in pixels.
Minimum: 40
Maximum: 8000
asset_idstringThe ID of an asset to insert into the created design. Currently, this only supports image assets.
titlestringThe name of the design.
Minimum length: 1
Maximum length: 255
Creating a copy of an existing design is currently provided as a preview. Be aware of the following:
- There might be unannounced breaking changes.
- Any breaking changes to preview features won't produce a new API version.
- Public integrations that use preview features will not pass the review process, and can't be made available to all Canva users.
Body parameters for creating a copy of an existing design.
typestringAvailable values: The only valid value is design.
design_idstringThe ID of the design to copy.
page_numbersinteger[]The pages to copy from the source design. If not specified, all pages are copied. Pages are indexed using one-based numbering.
Minimum items: 1
Creating a copy from a brand template is currently provided as a preview. Be aware of the following:
- There might be unannounced breaking changes.
- Any breaking changes to preview features won't produce a new API version.
- Public integrations that use preview features will not pass the review process, and can't be made available to all Canva users.
Body parameters for creating a copy from a brand template.
typestringAvailable values: The only valid value is brand_template.
brand_template_idstringThe ID of the brand template used to create a design copy.
page_numbersinteger[]The pages to copy from the brand template. If not specified, all pages are copied. Pages are indexed using one-based numbering.
Minimum items: 1
Example request
Examples for using the /v1/designs endpoint:
curl --request POST 'https://api.canva.com/rest/v1/designs' \--header 'Authorization: Bearer {token}' \--header 'Content-Type: application/json' \--data '{"type": "type_and_asset","design_type": {"type": "preset","name": "doc"},"asset_id": "Msd59349ff","title": "My Holiday Presentation"}'
const fetch = require("node-fetch");fetch("https://api.canva.com/rest/v1/designs", {method: "POST",headers: {"Authorization": "Bearer {token}","Content-Type": "application/json",},body: JSON.stringify({"type": "type_and_asset","design_type": {"type": "preset","name": "doc"},"asset_id": "Msd59349ff","title": "My Holiday Presentation"}),}).then(async (response) => {const data = await response.json();console.log(data);}).catch(err => console.error(err));
import java.io.IOException;import java.net.URI;import java.net.http.*;public class ApiExample {public static void main(String[] args) throws IOException, InterruptedException {HttpRequest request = HttpRequest.newBuilder().uri(URI.create("https://api.canva.com/rest/v1/designs")).header("Authorization", "Bearer {token}").header("Content-Type", "application/json").method("POST", HttpRequest.BodyPublishers.ofString("{\"type\": \"type_and_asset\", \"design_type\": {\"type\": \"preset\", \"name\": \"doc\"}, \"asset_id\": \"Msd59349ff\", \"title\": \"My Holiday Presentation\"}")).build();HttpResponse<String> response = HttpClient.newHttpClient().send(request,HttpResponse.BodyHandlers.ofString());System.out.println(response.body());}}
import requestsheaders = {"Authorization": "Bearer {token}","Content-Type": "application/json"}data = {"type": "type_and_asset","design_type": {"type": "preset","name": "doc"},"asset_id": "Msd59349ff","title": "My Holiday Presentation"}response = requests.post("https://api.canva.com/rest/v1/designs",headers=headers,json=data)print(response.json())
using System.Net.Http;var client = new HttpClient();var request = new HttpRequestMessage{Method = HttpMethod.Post,RequestUri = new Uri("https://api.canva.com/rest/v1/designs"),Headers ={{ "Authorization", "Bearer {token}" },},Content = new StringContent("{\"type\": \"type_and_asset\", \"design_type\": {\"type\": \"preset\", \"name\": \"doc\"}, \"asset_id\": \"Msd59349ff\", \"title\": \"My Holiday Presentation\"}",Encoding.UTF8,"application/json"),};using (var response = await client.SendAsync(request)){response.EnsureSuccessStatusCode();var body = await response.Content.ReadAsStringAsync();Console.WriteLine(body);};
package mainimport ("fmt""io""net/http""strings")func main() {payload := strings.NewReader(`{"type": "type_and_asset","design_type": {"type": "preset","name": "doc"},"asset_id": "Msd59349ff","title": "My Holiday Presentation"}`)url := "https://api.canva.com/rest/v1/designs"req, _ := http.NewRequest("POST", url, payload)req.Header.Add("Authorization", "Bearer {token}")req.Header.Add("Content-Type", "application/json")res, _ := http.DefaultClient.Do(req)defer res.Body.Close()body, _ := io.ReadAll(res.Body)fmt.Println(string(body))}
$curl = curl_init();curl_setopt_array($curl, array(CURLOPT_URL => "https://api.canva.com/rest/v1/designs",CURLOPT_CUSTOMREQUEST => "POST",CURLOPT_RETURNTRANSFER => true,CURLOPT_HTTPHEADER => array('Authorization: Bearer {token}','Content-Type: application/json',),CURLOPT_POSTFIELDS => json_encode(["type" => "type_and_asset","design_type" => ["type" => "preset","name" => "doc"],"asset_id" => "Msd59349ff","title" => "My Holiday Presentation"])));$response = curl_exec($curl);$err = curl_error($curl);curl_close($curl);if (empty($err)) {echo $response;} else {echo "Error: " . $err;}
require 'net/http'require 'uri'url = URI('https://api.canva.com/rest/v1/designs')http = Net::HTTP.new(url.host, url.port)http.use_ssl = truerequest = Net::HTTP::Post.new(url)request['Authorization'] = 'Bearer {token}'request['Content-Type'] = 'application/json'request.body = <<REQUEST_BODY{"type": "type_and_asset","design_type": {"type": "preset","name": "doc"},"asset_id": "Msd59349ff","title": "My Holiday Presentation"}REQUEST_BODYresponse = http.request(request)puts response.read_body
Success response
If successful, the endpoint returns a 200 response with a JSON body with the following parameters:
designDesignThe design object, which contains metadata about the design.
idstringThe design ID.
ownerTeamUserSummaryMetadata for the user, consisting of the User ID and Team ID.
user_idstringThe ID of the user.
team_idstringThe ID of the user's Canva Team.
urlsDesignLinksA temporary set of URLs for viewing or editing the design.
edit_urlstringA temporary editing URL for the design. This URL is only accessible to the user that made the API request, and is designed to support return navigation workflows.
This is not a permanent URL, it is only valid for 30 days.
view_urlstringA temporary viewing URL for the design. This URL is only accessible to the user that made the API request, and is designed to support return navigation workflows.
This is not a permanent URL, it is only valid for 30 days.
created_atintegerWhen the design was created in Canva, as a Unix timestamp (in seconds since the Unix Epoch).
updated_atintegerWhen the design was last updated in Canva, as a Unix timestamp (in seconds since the Unix Epoch).
titlestringThe design title.
thumbnailThumbnailA thumbnail image representing the object.
widthintegerThe width of the thumbnail image in pixels.
heightintegerThe height of the thumbnail image in pixels.
urlstringA URL for retrieving the thumbnail image. This URL expires after 15 minutes. This URL includes a query string that's required for retrieving the thumbnail.
page_countintegerThe total number of pages in the design. Some design types don't have pages (for example, Canva docs).
Example response
{"design": {"id": "DAFVztcvd9z","title": "My summer holiday","owner": {"user_id": "auDAbliZ2rQNNOsUl5OLu","team_id": "Oi2RJILTrKk0KRhRUZozX"},"thumbnail": {"width": 595,"height": 335,"url": "https://document-export.canva.com/Vczz9/zF9vzVtdADc/2/thumbnail/0001.png?<query-string>"},"urls": {"edit_url": "https://www.canva.com/api/design/eyJhbGciOiJkaXIiLCJlbmMiOiJBMjU2R0NNIiwiZXhwaXJ5IjoxNzQyMDk5NDAzMDc5fQ..GKLx2hrJa3wSSDKQ.hk3HA59qJyxehR-ejzt2DThBW0cbRdMBz7Fb5uCpwD-4o485pCf4kcXt_ypUYX0qMHVeZ131YvfwGPIhbk-C245D8c12IIJSDbZUZTS7WiCOJZQ.sNz3mPSQxsETBvl_-upMYA/edit","view_url": "https://www.canva.com/api/design/eyJhbGciOiJkaXIiLCJlbmMiOiJBMjU2R0NNIiwiZXhwaXJ5IjoxNzQyMDk5NDAzMDc5fQ..GKLx2hrJa3wSSDKQ.hk3HA59qJyxehR-ejzt2DThBW0cbRdMBz7Fb5uCpwD-4o485pCf4kcXt_ypUYX0qMHVeZ131YvfwGPIhbk-C245D8c12IIJSDbZUZTS7WiCOJZQ.sNz3mPSQxsETBvl_-upMYA/view"},"created_at": 1377396000,"updated_at": 1692928800,"page_count": 5}}
Error responses
404 Not Found
codestringA short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see Error responses.
messagestringA human-readable description of what went wrong.
Example error responses
A design with the ID specified in the request could not be found.
{"code": "not_found","message": "Design with id '{designId}' not found"}
A brand template with the ID specified in the request could not be found.
{"code": "not_found","message": "Brand template with id '{brandTemplateId}' not found"}